## Contributing OpenStack4j

Thank you for your interest in contributing to the OpenStack4j API.

We are building this software together and strongly encourage contributions
from the community that are within the guidelines set forth below.

Bug Fixes and New Features
--------------------------

Before starting to write code, look for existing [tickets]
(https://github.com/ContainX/openstack4j/issues?state=open) or [create one]
(https://github.com/ContainX/openstack4j/issues/new) 
for your bug, issue, or feature request. This helps the community
avoid working on something that might not be of interest or which
has already been addressed.

Pull Requests
-------------

Pull requests should be made against the master (development)
branch and include relevant tests, if applicable. 

Code should compile and tests should pass under all Java versions 
which the OpenStack4j currently supports.
Refer to [unit tests README](./core-test/README.md) or [integration tests README](./core-integration-test/README.md) for more details on how to write tests.
Currently we support a minimum version of Java 7.

Please insure all code is formatted like the rest of the API, well documented and same patterns applied. When configuring your IDE workspace make sure tabs are represented as spaces.

Chat With Me
------------

If you want to work on something or have questions / complaints please reach
out to me by creating a Question issue at https://github.com/ContainX/openstack4j/issues/new or better yet join our group at http://groups.google.com/group/openstack4j

Thank you for your support!

Jeremy Unruh
